/*
Especie criada por:

Ana Maria Gracioso Martins
Marina Trombetta Lima

*/

#include "funcs.h"
#include "motor.h"

#define NOME Brancaleone

extern int gasto[5];

INTENCAO leone (favo viz [5][5]){
  INTENCAO leone;
  leone.acao=FORTALECE;
  leone.pub[0]=42;
  static int menor, ataq;

  /*ocupao com a vizinhana do favo a ser ocupado vazia ou com nossa espcie presente*/
 
  if(viz[1][2].esp == 0) {

    if (((viz[1][1].esp == 0) || (viz[1][1].esp == viz[2][2].esp)) && 
	((viz[0][2].esp == 0) || (viz[0][2].esp == viz[2][2].esp)) && 
	((viz[1][3].esp == 0) ||( viz[1][3].esp == viz[2][2].esp))){
      leone.dir = NORTE;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    }
  }

  if(viz[2][3].esp == 0){
    
    if(viz[1][3].esp == 0 && viz[2][4].esp == 0 && viz[3][3].esp == 0 ){
      leone.dir = LESTE;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    }
    
    if(viz[1][3].esp == 0 && 
       viz[2][4].esp == viz[2][2].esp && 
       viz[3][3].esp == 0){
      leone.dir = LESTE;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    } 
  }

  if(viz[3][2].esp==0) {

    if(viz[3][1].esp == 0 && viz[4][2].esp == 0 && viz[3][3].esp == 0){
      leone.dir = SUL;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    } 

    if(viz[3][1].esp == 0 && 
       viz[4][2].esp == viz[2][2].esp && 
       viz[3][3].esp == 0){
      leone.dir = SUL;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    } 
  }


  if(viz[2][1].esp==0) {

    if(viz[1][1].esp == 0 && viz[2][0].esp == 0 && viz[3][1].esp == 0){
      leone.dir = OESTE;
      leone.acao = OCUP;
      leone.param = (viz [2][2].atp/2);
      return leone;  
    } 
  }

  
  /*Simples Ocupacao (olhando primeira fila), 
    condicao: nenhum dos favos da fila ocupado pela espcie*/

   if (viz[1][3].esp == 0 && 
      viz[2][3].esp == 0 &&
      viz[3][3].esp == 0){
    leone.dir = LESTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  }
  
  if (viz[3][1].esp == 0 &&
      viz[3][2].esp == 0 &&
      viz[3][3].esp == 0){
    leone.dir = SUL; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  } 

  if (viz[1][1].esp == 0 &&
      viz[2][1].esp == 0 &&
      viz[3][1].esp == 0){
    leone.dir = OESTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  }

  if (viz[1][1].esp == 0 &&
      viz[1][2].esp == 0 &&
      viz[1][3].esp == 0){
    leone.dir = NORTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
    }

  
  /*Simples Ocupacao (olhando direcao horizontal), 
    condicao: favos da fila ocupados pela espcie*/

  if ((((viz[2][3].esp == viz [2][2].esp) &&(viz[2][4].esp == viz [2][2].esp))||
       ((viz[2][1].esp == viz [2][2].esp) && (viz[2][0].esp == viz [2][2].esp))) &&
      (viz[1][2].esp == 0)){
    leone.dir = NORTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  }

  if ((((viz[2][3].esp == viz [2][2].esp) &&(viz[2][4].esp == viz [2][2].esp))||
       ((viz[2][1].esp == viz[2][2].esp) &&(viz[2][0].esp == viz [2][2].esp))) &&
      (viz[1][2].esp == 0)){
    leone.dir = SUL; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  }


  /*Simples Ocupacao (olhando direcao vertical),
    condicao: favos da fila ocupados pela espcie*/
  
  if((((viz[1][2].esp == viz [2][2].esp) && (viz[0][2].esp == viz [2][2].esp))||
      ((viz[3][2].esp == viz [2][2].esp) && (viz[4][2].esp == viz [2][2].esp))) &&
     (viz[2][1].esp == 0)){
    leone.dir = OESTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  } 

  if((((viz[1][2].esp == viz [2][2].esp) && (viz[0][2].esp==viz [2][2].esp))||
      ((viz[3][2].esp==viz [2][2].esp) && (viz[4][2].esp==viz [2][2].esp))) &&
     (viz[2][3].esp==0)){
    leone.dir = LESTE; 
    leone.acao = OCUP;
    leone.param = (viz[2][2].atp/2);
    return leone;
  } 
 

  /*Ocupacao com condicao*/

  if ((viz[1][3].esp==0 || viz[3][3].esp==0) &&
      viz[2][3].esp==0){
    leone.dir=LESTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;}
  
  if((viz[3][1].esp==0||viz[3][3].esp==0) &&
     viz[3][2].esp==0){
    leone.dir=SUL; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  } 

  if ((viz[1][1].esp==0||viz[3][1].esp==0) &&
      viz[2][1].esp==0){
    leone.dir=OESTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  } 

  if((viz[1][1].esp==0||viz[1][3].esp==0) &&
     viz[1][2].esp==0){
    leone.dir=NORTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  }

  /*Ocupacao simples*/

  if (viz[2][3].esp==0){
    leone.dir=LESTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  }
  
  if (viz[3][2].esp==0){
    leone.dir=SUL; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  } 
  
  if (viz[2][1].esp==0){
    leone.dir=OESTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  }

  if (viz[1][2].esp==0){
    leone.dir=NORTE; 
    leone.acao=OCUP;
    leone.param=(viz[2][2].atp/2);
    return leone;
  }

  /*Ataque condicionado, tentativa falha de evitar o  desperdcio de atps*/

  if (viz[2][2].atp > (gasto[ATAQUE] + 3)){

    ataq = (viz[2][2].atp - gasto[ATAQUE] - 2);

    if ((viz[1][2].esp) &&
	(viz[1][2].esp != viz[2][2].esp) &&
	(viz[1][2].atp < (viz[2][2].atp - gasto[ATAQUE] - 1))){
      ataq = viz[1][2].atp;
    }


    if ((viz[3][2].esp) &&
	(viz[3][2].esp != viz[2][2].esp) &&
	(viz[3][2].atp < (viz[2][2].atp - gasto[ATAQUE] - 1))){
      ataq = viz[3][2].atp;
    }
	  
    if ((viz[2][1].esp) &&
	(viz[2][1].esp != viz[2][2].esp) &&
	(viz[2][1].atp < (viz[2][2].atp - gasto[ATAQUE] - 1))){
      ataq = viz[2][1].atp;
    }    

    if ((viz[2][3].esp) &&
	(viz[2][3].esp != viz[2][2].esp) &&
	(viz[2][3].atp < (viz[2][2].atp - gasto[ATAQUE] - 1))){
      ataq = viz[2][3].atp;
    } 

    if((ataq == viz[1][2].atp) &&
       (viz[1][2].esp) &&
       (viz[1][2].esp != viz[2][2].esp)){
      leone.dir=NORTE;
      leone.acao=ATAQUE;
      leone.param = ((viz [2][2].atp)/2);
      return leone;
    }  
	 
    if ((ataq == viz[3][2].atp) &&
	(viz[3][2].esp) &&
	(viz[3][2].esp != viz[2][2].esp)){
      leone.dir=SUL;
      leone.acao=ATAQUE;
      leone.param = ((viz [2][2].atp)/2);
      return leone;
    } 

    if ((ataq == viz[2][1].atp) &&
	(viz[2][1].esp) &&
	(viz[2][1].esp != viz[2][2].esp)){
      leone.dir=OESTE;
      leone.acao=ATAQUE;
      leone.param =((viz [2][2].atp)/2);
      return leone;
    }  
    
    if ((ataq == viz[2][3].atp) &&
	(viz[2][3].esp) &&
	(viz[2][3].esp != viz[2][2].esp)){
      leone.dir = LESTE;
      leone.acao = ATAQUE;
      leone.param =((viz [2][2].atp)/2);
      return leone;
    }
	 
  }

  /*Antiga*/

  if (viz[2][2].atp > 3 + gasto[ATAQUE] &&
      viz[1][2].esp != 0                &&
      viz[1][2].esp != viz[2][2].esp){
    leone.dir=NORTE;
    leone.acao=ATAQUE;
    leone.param=((viz [2][2].atp - gasto[ATAQUE] - 1));
    return leone;
  }  
  
  if (viz[2][2].atp>3+gasto[ATAQUE]  && 
      viz[3][2].esp!=0               &&
      viz[3][2].esp!=viz[2][2].esp){
    leone.dir=SUL;
    leone.acao=ATAQUE;
    leone.param=((viz [2][2].atp)/2);
    return leone;
  } 
  
  if (viz[2][2].atp>3+gasto[ATAQUE] && 
      viz[2][1].esp!=0				&&
      viz[2][1].esp!=viz[2][2].esp){
    leone.dir=OESTE;
    leone.acao=ATAQUE;
    leone.param=((viz [2][2].atp)/2);
    return leone;
  }
  
  if (viz[2][2].atp > 3+gasto[ATAQUE] &&
      viz[2][3].esp != 0				&&
      viz[2][3].esp != viz[2][2].esp){
    leone.dir = LESTE;
    leone.acao = ATAQUE;
    leone.param = ((viz [2][2].atp)/2);
    return leone;
  }
 
  /*Transferencia condicionada, verifica se clulas de outra espcie esto presentes na viz*/


  if (viz[1][2].esp == viz[2][2].esp) {
    if(((viz [0][3].esp) && (viz[0][3].esp!=viz[2][2].esp)) ||
       ((viz[0][2].esp) && (viz[1][2].esp != viz[0][2].esp)) || 
       ((viz[0][1].esp) && (viz[2][2].esp != viz[0][1].esp))) { 
      leone.dir = NORTE;
      leone.acao = TRANSF;
      leone.param = viz[2][2].atp - 1;
      return leone;
    }
  }
    
    
  if (viz[2][3].esp == viz[2][2].esp) {
    if(((viz [2][4].esp) && (viz[2][4].esp!=viz[2][2].esp)) || 
       ((viz[1][4].esp) && (viz[1][4].esp != viz[2][2].esp)) ||
       ((viz[3][4].esp) && (viz[2][2].esp != viz[3][4].esp))) { 
      leone.dir = LESTE;
      leone.acao = TRANSF;
      leone.param = viz[2][2].atp - 1;
      return leone;
    }
  }
    
  if (viz[3][2].esp == viz[2][2].esp) {
    if(((viz [4][1].esp) && (viz[4][1].esp!=viz[2][2].esp)) || 
       ((viz[4][2].esp) && (viz[4][2].esp != viz[2][2].esp)) || 
       ((viz[4][3].esp) && (viz[2][2].esp != viz[4][3].esp))) { 
      leone.dir = SUL;
      leone.acao = TRANSF;
      leone.param = viz[2][2].atp - 1;
      return leone;
    }
  }
  if (viz[2][1].esp == viz[2][2].esp) {
    if(((viz [1][0].esp) && (viz[1][0].esp!=viz[2][2].esp)) || 
       ((viz[2][0].esp) && (viz[2][0].esp != viz[2][2].esp)) || 
       ((viz[3][0].esp) && (viz[3][0].esp != viz[2][2].esp))) { 
      leone.dir = OESTE;
      leone.acao = TRANSF;
      leone.param = viz[2][2].atp - 1;
      return leone;
    }
  }

  // Transf levando em conta as pontas

  if ((viz[1][2].esp == viz[2][2].esp) &&
      (viz[1][2].atp < viz[2][2].atp)) {
    if((viz [0][0].esp) && (viz[0][0].esp!=viz[2][2].esp)){ 
      leone.dir = NORTE;
      leone.acao = TRANSF;
      leone.param = (viz[2][2].atp - viz[1][2].atp);
      return leone;
    }
  }
    
    
  if ((viz[2][3].esp == viz[2][2].esp) &&
      (viz[2][3].atp < viz[2][2].atp)) {
    if((viz [0][4].esp) && (viz[0][4].esp!=viz[2][2].esp)) { 
      leone.dir = LESTE;
      leone.acao = TRANSF;
      leone.param = (viz[2][2].atp - viz[2][3].atp);
      return leone;
    }
  }
    
  if ((viz[3][2].esp == viz[2][2].esp) &&
      (viz[3][2].atp < viz[2][2].atp)) {
    if((viz [4][4].esp) && (viz[4][4].esp!=viz[2][2].esp)){ 
      leone.dir = SUL;
      leone.acao = TRANSF;
      leone.param = (viz[2][2].atp - viz[3][2].atp);
      return leone;
    }
  } 

  if ((viz[2][1].esp == viz[2][2].esp) &&
      (viz[2][1].atp < viz[2][2].atp)) {
    if((viz [4][0].esp) && (viz[4][0].esp!=viz[2][2].esp)) { 
      leone.dir = OESTE;
      leone.acao = TRANSF;
      leone.param = (viz[2][2].atp -viz[2][1].atp);
      return leone;
    }
  }
  /*Transferencia condicionada se as condies acima no forem satisfeitas*/
  
  if((viz[1][2].esp == viz[2][2].esp)  &&
     (viz[2][1].esp == viz[2][2].esp) &&
     (viz[3][2].esp == viz[2][2].esp) &&
     (viz[2][3].esp == viz[2][2].esp)){
    menor = viz[2][2].atp;

    if (viz[2][2].atp > viz[1][2].atp){
      menor = viz[1][2].atp;
    }
	
    if ((viz[2][2].atp > viz[3][2].atp) && (menor > viz[3][2].atp)){
      menor = viz[3][2].atp;
    }

    if ((viz[2][2].atp > viz[2][1].atp) && (menor > viz[2][1].atp)){
      menor = viz[2][1].atp; 
    }

    if ((viz[2][2].atp > viz[2][3].atp) && (menor > viz[2][3].atp)){
      menor = viz[2][3].atp;
    }

    if (viz[2][2].atp == menor){
      leone.acao = FORTALECE;
      leone.param = 0;
    }

    else {
      if (menor == viz[1][2].atp){ 
	leone.dir=NORTE;
	leone.acao=TRANSF;
	leone.param = (viz[2][2].atp - viz[1][2].atp);
	return leone;
      }
      if (menor == viz[3][2].atp){
	leone.dir = SUL;
	leone.acao = TRANSF;
	leone.param = (viz[2][2].atp - viz[3][2].atp);
	return leone;
      }
      if (menor == viz[2][1].atp){
	leone.dir = OESTE;
	leone.acao = TRANSF;
	leone.param = (viz[2][2].atp - viz[2][1].atp);
	return leone;
      }
      if (menor == viz[2][3].atp){
	leone.dir = LESTE;
	leone.acao = TRANSF;
	leone.param = (viz[2][2].atp - viz[2][3].atp);
	return leone;
      }
    }
    leone.param = 0;
    return leone;
  }

  leone.acao = FORTALECE;
  leone.param = 0;
  return leone;
}

