/*
Especie craida por:

Vitor Eiji Justus Sakaguti

*/

#include "funcs.h"
#include "motor.h"

#define NOME mofo
#define EU vizi[RAIO_VISAO][RAIO_VISAO]
#define VN vizi[RAIO_VISAO-1][RAIO_VISAO]
#define VL vizi[RAIO_VISAO][RAIO_VISAO+1]
#define VS vizi[RAIO_VISAO+1][RAIO_VISAO]
#define VO vizi[RAIO_VISAO][RAIO_VISAO-1]
#define VNN vizi[RAIO_VISAO-2][RAIO_VISAO]
#define VLL vizi[RAIO_VISAO][RAIO_VISAO+2]
#define VSS vizi[RAIO_VISAO+2][RAIO_VISAO]
#define VOO vizi[RAIO_VISAO][RAIO_VISAO-2]


typedef enum
{
  TISO, /* Totalmente isolada */
  PISO, /* Parcialmente isolada */
  TINT, /* Totalmente interna */
  PINT, /* Parcialmente interna */
  NBOR, /* Borda norte. */
  LBOR, /* Borda leste. */
  SBOR, /* Borda sul. */
  OBOR, /* Borda oeste. */
} CARGO;


/* operando bit-a-bit: var |= 1<<3 seta o 3o bit para 1 */

INTENCAO b (favo f[5][5]);
/* void comunica(int *v, int *uia); /\* Escreve as mensagens no vetor pblico *\/ */
/* void interpreta(int *v, int *uia) /\* Interpreta o vetor pblico *\/ */
CARGO deccar (favo vizi[5][5]); /* Decide qual  o cargo da clula olhando para vizinhana*/
INTENCAO tiso(INTENCAO vai, favo vizi[5][5]);
INTENCAO piso(INTENCAO vai, favo vizi[5][5]);
INTENCAO tint(INTENCAO vai, favo vizi[5][5]);
INTENCAO pint(INTENCAO vai, favo vizi[5][5]);
INTENCAO nbor(INTENCAO vai, favo vizi[5][5]);
INTENCAO lbor(INTENCAO vai, favo vizi[5][5]);
INTENCAO sbor(INTENCAO vai, favo vizi[5][5]);
INTENCAO obor(INTENCAO vai, favo vizi[5][5]);

/* INTENCAO bizz(INTENCAO vai, int *uia); /\* Bizzarra (em caso de desespero) *\/ */

extern int gasto[5];
extern int popespecies[NUM_ESP+1];
extern int iteracoes;

CARGO deccar (favo vizi[5][5])
{
  int i,j,k;

  /* Vendo se  totalmente interna */
  k=0;
  for(i=0;i<=2*RAIO_VISAO;i++)
  {
    for(j=0;j<=2*RAIO_VISAO;j++)
    {
      if (vizi[i][j].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
    }
  }
  if(k==(RAIO_VISAO+1)*(RAIO_VISAO+1)) return TINT;

  /* Vendo se  parcialmente interna */
  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    for(j=RAIO_VISAO -1;j<=RAIO_VISAO +1; j++)
      {
	if (vizi[i][j].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
      }
  }
  if(k==9) return PINT;

  /* Vendo se  de borda */
  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    if (vizi[i][RAIO_VISAO -1].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
  }
  if(k==3) return LBOR;

  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    if (vizi[i][RAIO_VISAO +1].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
  }
  if(k==3) return OBOR;

  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    if (vizi[RAIO_VISAO -1][i].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
  }
  if(k==3) return SBOR;

  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    if (vizi[RAIO_VISAO +1][i].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++;
  }
  if(k==3) return NBOR;

  /* Vendo se  totalmente isolada */
  k=0;
  for(i=0;i<=2*RAIO_VISAO;i++)
  {
    for(j=0;j<=2*RAIO_VISAO;j++)
    {
      if (vizi[i][j].esp==0) k++;
    }
  }
  if (k==EU.esp) return TISO;

  /* Vendo se  parcialmente isolada */
  k=0;
  for(i=RAIO_VISAO -1;i<=RAIO_VISAO +1; i++)
  {
    for(j=RAIO_VISAO -1;j<=RAIO_VISAO +1; j++)
      {
	k+=vizi[i][j].esp;
	/* if (vizi[i][j].esp==vizi[RAIO_VISAO][RAIO_VISAO].esp) k++; */
      }
  }
  if(k!=0) return PISO;

  return PISO; /* S at eu pensar em algo melhor... */
}

/* void comunica(int *v, int *uia) */
/* { */
/*   *(uia+0)=*(v+0); */
/*   *(uia+0)<<=(3*8); */

/*   *(uia+1)=*(v+1); */

/*   *(uia+2)=*(v+2); */

/*   *(uia+3)=*(v+3); */

/* } */

/* void interpreta(int *v, int *uia) */
/* { */

/* } */

INTENCAO tint(INTENCAO vai, favo vizi[5][5])
{
  int i=0,j=0;

  vai.acao=TRANSF;

  if (*(vai.pub+0)>=*(vai.pub+1)&&*(vai.pub+0)>=*(vai.pub+2)&&*(vai.pub+0)>=*(vai.pub+3)) vai.dir=NORTE;
  if (*(vai.pub+1)>=*(vai.pub+0)&&*(vai.pub+1)>=*(vai.pub+2)&&*(vai.pub+1)>=*(vai.pub+3)) vai.dir=LESTE;
  if (*(vai.pub+2)>=*(vai.pub+0)&&*(vai.pub+2)>=*(vai.pub+1)&&*(vai.pub+2)>=*(vai.pub+3)) vai.dir=SUL;
  if (*(vai.pub+3)>=*(vai.pub+0)&&*(vai.pub+3)>=*(vai.pub+1)&&*(vai.pub+3)>=*(vai.pub+2)) vai.dir=OESTE;
  
  vai.pub[0]=vizi[0][RAIO_VISAO].pub[0];
  vai.pub[1]=vizi[RAIO_VISAO][2*RAIO_VISAO].pub[1];
  vai.pub[2]=vizi[2*RAIO_VISAO][RAIO_VISAO].pub[2];
  vai.pub[3]=vizi[RAIO_VISAO][0].pub[3];
  
  switch(vai.dir)
  {
  case NORTE : for(i=MAX_ATP-VNN.atp;VN.atp-i<=0;i--){}
               for(j=10-(VN.atp-i);EU.atp-j<=0;j--){}
	       break;

  case LESTE : for(i=MAX_ATP-VLL.atp;VL.atp-i<=0;i--){}
               for(j=10-(VL.atp-i);EU.atp-j<=0;j--){}
	       break;

  case  SUL  : for(i=MAX_ATP-VSS.atp;VS.atp-i<=0;i--){}
               for(j=10-(VS.atp-i);EU.atp-j<=0;j--){}
	       break;

  case OESTE : for(i=MAX_ATP-VOO.atp;VO.atp-i<=0;i--){}
               for(j=10-(VO.atp-i);EU.atp-j<=0;j--){}
	       break;
  }

  vai.param=j;

  return vai;
}

INTENCAO pint(INTENCAO vai,favo vizi[5][5])
{
  int i=0,j=0;

  vai.acao=TRANSF;

  if (*(vai.pub+0)>=*(vai.pub+1)&&*(vai.pub+0)>=*(vai.pub+2)&&*(vai.pub+0)>=*(vai.pub+3)) vai.dir=NORTE;
  if (*(vai.pub+1)>=*(vai.pub+0)&&*(vai.pub+1)>=*(vai.pub+2)&&*(vai.pub+1)>=*(vai.pub+3)) vai.dir=LESTE;
  if (*(vai.pub+2)>=*(vai.pub+0)&&*(vai.pub+2)>=*(vai.pub+1)&&*(vai.pub+2)>=*(vai.pub+3)) vai.dir=SUL;
  if (*(vai.pub+3)>=*(vai.pub+0)&&*(vai.pub+3)>=*(vai.pub+1)&&*(vai.pub+3)>=*(vai.pub+2)) vai.dir=OESTE;
  
  vai.pub[0]=VN.pub[0];
  vai.pub[1]=VL.pub[1];
  vai.pub[2]=VS.pub[2];
  vai.pub[3]=VO.pub[3];
  
  switch(vai.dir)
  {
  case NORTE : for(i=MAX_ATP-VN.atp;EU.atp-i<=0;i--){} break;
  case LESTE : for(i=MAX_ATP-VL.atp;EU.atp-i<=0;i--){} break;
  case  SUL  : for(i=MAX_ATP-VS.atp;EU.atp-i<=0;i--){} break;
  case OESTE : for(i=MAX_ATP-VO.atp;EU.atp-i<=0;i--){} break;
  }
  vai.param=i;

  return vai;
}

INTENCAO nbor(INTENCAO vai, favo vizi[5][5])
{  
  vai.pub[0]=iteracoes;
  vai.pub[1]=VL.pub[1];
  vai.pub[2]=VS.pub[2];
  vai.pub[3]=VO.pub[3];
 
  vai.dir=NORTE;

  vai.param=EU.atp-1;

  if(VN.esp==0)
  {
    vai.acao=OCUP;
    vai.futpub[0]=iteracoes;
    vai.futpub[1]=iteracoes;
    vai.futpub[2]=iteracoes;
    vai.futpub[3]=iteracoes;
  }

  if(VN.esp!=EU.esp) vai.acao=ATAQUE;
}

INTENCAO lbor(INTENCAO vai, favo vizi[5][5])
{  
  vai.pub[0]=VN.pub[0];
  vai.pub[1]=iteracoes;
  vai.pub[2]=VS.pub[2];
  vai.pub[3]=VO.pub[3];

  vai.dir=LESTE;
  
  vai.param=EU.atp-1;

  if(VL.esp==0)
  {
    vai.acao=OCUP;
    vai.futpub[0]=iteracoes;
    vai.futpub[1]=iteracoes;
    vai.futpub[2]=iteracoes;
    vai.futpub[3]=iteracoes;
  }

  if(VL.esp!=EU.esp) vai.acao=ATAQUE;
}

INTENCAO sbor(INTENCAO vai, favo vizi[5][5])
{
  vai.pub[0]=VN.pub[0];
  vai.pub[1]=VL.pub[1];
  vai.pub[2]=iteracoes;
  vai.pub[3]=VO.pub[3];

  vai.dir=SUL;

  vai.param=EU.atp-1;

  if(VS.esp==0)
  {
    vai.acao=OCUP;
    vai.futpub[0]=iteracoes;
    vai.futpub[1]=iteracoes;
    vai.futpub[2]=iteracoes;
    vai.futpub[3]=iteracoes;
  }

  if(VS.esp!=EU.esp) vai.acao=ATAQUE;
}

INTENCAO obor(INTENCAO vai, favo vizi[5][5])
{
  vai.pub[0]=VN.pub[0];
  vai.pub[1]=VL.pub[1];
  vai.pub[2]=VS.pub[2];
  vai.pub[3]=iteracoes;
  
  vai.dir=OESTE;
  
  vai.param=EU.atp-1;

  if(VO.esp==0)
  {
    vai.acao=OCUP;
    vai.futpub[0]=iteracoes;
    vai.futpub[1]=iteracoes;
    vai.futpub[2]=iteracoes;
    vai.futpub[3]=iteracoes;
  }

  if(VO.esp!=EU.esp) vai.acao=ATAQUE;
}

INTENCAO piso(INTENCAO vai, favo vizi[5][5])
{
    if (vizi[1][3].esp==0 && 
	  vizi[3][3].esp==0 &&
	  vizi[2][3].esp==0){
    vai.dir=LESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }
  
  if (vizi[3][1].esp==0 &&
	  vizi[3][3].esp==0 &&
	  vizi[3][2].esp==0){
    vai.dir=SUL; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  } 

  if (vizi[1][1].esp==0 &&
	  vizi[3][1].esp==0 &&
	  vizi[2][1].esp==0){
    vai.dir=OESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

  if (vizi[1][1].esp==0 &&
	  vizi[1][3].esp==0 &&
	  vizi[1][2].esp==0){
    vai.dir=NORTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

   if ((vizi[1][3].esp==0 || vizi[3][3].esp==0) &&
	   vizi[2][3].esp==0){
    vai.dir=LESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;}
  
  if((vizi[3][1].esp==0||vizi[3][3].esp==0) &&
	 vizi[3][2].esp==0){
    vai.dir=SUL; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  } 

  if ((vizi[1][1].esp==0||vizi[3][1].esp==0) &&
	  vizi[2][1].esp==0){
    vai.dir=OESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

  if((vizi[1][1].esp==0||vizi[1][3].esp==0) &&
	 vizi[1][2].esp==0){
    vai.dir=NORTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

  if (vizi[2][3].esp==0){
    vai.dir=LESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }
  
  if (vizi[3][2].esp==0){
    vai.dir=SUL; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  } 
  
  if (vizi[2][1].esp==0){
    vai.dir=OESTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

  if (vizi[1][2].esp==0){
    vai.dir=NORTE; 
    vai.acao=OCUP;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }


  if (vizi[2][2].atp > 2+gasto[ATAQUE] &&
	  vizi[1][2].esp!=0                &&
	  vizi[1][2].esp!=vizi[2][2].esp){
    vai.dir=NORTE;
    vai.acao=ATAQUE;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }
  if (vizi[2][2].atp>2+gasto[ATAQUE]  && 
	  vizi[3][2].esp!=0               &&
	  vizi[3][2].esp!=vizi[2][2].esp){
    vai.dir=SUL;
    vai.acao=ATAQUE;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  } 
  if (vizi[2][2].atp>2+gasto[ATAQUE] && 
	  vizi[2][1].esp!=0				&&
	  vizi[2][1].esp!=vizi[2][2].esp){
    vai.dir=OESTE;
    vai.acao=ATAQUE;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }
  if (vizi[2][2].atp>2+gasto[ATAQUE] &&
	  vizi[2][3].esp!=0				&&
	  vizi[2][3].esp!=vizi[2][2].esp){
    vai.dir=LESTE;
    vai.acao=ATAQUE;
    vai.param=(vizi[2][2].atp/2);
    return vai;
  }

  if (vizi[1][2].esp==vizi[2][2].esp &&
	  vizi[2][1].esp==vizi[2][2].esp &&
	  vizi[3][2].esp==vizi[2][2].esp &&
	  vizi[2][3].esp==vizi[2][2].esp){

    if (vizi[2][2].atp>vizi[1][2].atp){
      vai.dir=NORTE;
      vai.acao=TRANSF;
      vai.param=vizi[2][2].atp -vizi[1][2].atp;
      return vai;
	}

	if (vizi[2][2].atp>vizi[3][2].atp){
      vai.dir=SUL;
      vai.acao=TRANSF;
      vai.param=vizi[2][2].atp -vizi[3][2].atp;
      return vai;
}
	if (vizi[2][2].atp>vizi[2][1].atp){
      vai.dir=OESTE;
      vai.acao=TRANSF;
      vai.param=vizi[2][2].atp -vizi[2][1].atp;
      return vai;
	}
	if (vizi[2][2].atp>vizi[2][3].atp){
      vai.dir=LESTE;
      vai.acao=TRANSF;
      vai.param=vizi[2][2].atp -vizi[2][3].atp;
      return vai;
	}
  } 
  
  vai.param=0;
  return vai;
}

INTENCAO tiso(INTENCAO vai, favo vizi[5][5])
{
  vai.acao=OCUP;
  vai.dir=NORTE;
  vai.param=EU.atp-1;
  vai.futpub[2]=iteracoes;
}

INTENCAO b (favo vizi[5][5])
{
  INTENCAO vai;
  CARGO car;

  vai.acao=FORTALECE; /* TRANSF, ATAQUE, OCUP, FORTALECE, ILEGAL */
  vai.dir=NORTE; /* NORTE, LESTE, SUL, OESTE */
  vai.param=0; /* Quantos ATPs sero gastos?*/
/*   vai.pub={0,}; */
/*   vai.futpub={0,}; */

  car=deccar(vizi);

  switch (car)
{
 case TISO : vai=tiso(vai,vizi); break;
 case PISO : vai=piso(vai,vizi); break;
 case TINT : vai=tint(vai,vizi); break;
 case PINT : vai=pint(vai,vizi); break;
 case NBOR : vai=nbor(vai,vizi); break;
 case LBOR : vai=lbor(vai,vizi); break;
 case SBOR : vai=sbor(vai,vizi); break;
 case OBOR : vai=obor(vai,vizi); break;
 default : vai=piso(vai,vizi); break;
}

return vai;
}
