/* Especie The Knights Who say Ni! de 
Alex Kunze Susemihl NUSP:4895243
Ubiratan Augusto Lima NUSP:Desconhecido.
*/

#include<stdlib.h>
#include"funcs.h"
#include"motor.h"
#include<stdio.h>
#include "catalogo.h"
#define Viz(X,Y) viz[2+(X)][2+(Y)]
#define NN viz[1][2]
#define S viz[3][2]
#define O viz[2][1]
#define L viz[2][3]
#define NOME The Knight Who says Ni!

INTENCAO massacre2 (favo ziv[5][5]);


/* abaixo est a simbologia para o vetor viz,

|CE2|  |C1|   |C2|  |C3|   |CD2|
|E1|   |CE1|  |C|   |CD1|  |D1|
|E2|   |E|    |EU|   |D|    |D2|
|E3|   |BE1|  |B|   |BD1|  |D3|
|BE2|  |B1|   |B2|  |B3|   |BD2|

*/
  
/* variveis globais */
extern int gasto[5];
extern int popespecies[NUM_ESP+1];
extern int iteracoes;
INTENCAO carnica;
favo viz[LADOVIZ][LADOVIZ];
favo trans[LADOVIZ][LADOVIZ];
favo arredores[4];
int adjO[4];
int adjA[4];
int adjT[4];
int adjT2[4];
int primo[PRIMO];

static int daatp(DIRECAO);
static int atp(DIRECAO);
static int dapub(DIRECAO,int)
void carregaprimos();
void transpoe(int);
int varretransO(int);
int varretransT(int, int);
void ocupamax(int);
void atacamax(int);
void transfmax(int);
int maior(int v[4]);
int menor(int v[4]);
void zeravetor(int v[4]);
void carregaadjO();
void carregaadjT();
void multprimo(favo, int, int);
int multprimo2(int, int);
int potencia(int, int);



extern int gasto[5];

extern int popespecies[NUM_ESP+1];

/*A funcao daatp devolve um valor inteiro que se relaciona com o numero de 
atps inimigos nesta direcao e com o numero de celulas vazias ou aliadas
adjacentes (celulas inimigas aumentam o valor de daatp e aliadas ou vazias
diminuem).*/

static int daatp(DIRECAO a){
  int i=0,j=0,ret=0; 
  if(a==NORTE)  ret+=2*NN.atp;
  if(a==LESTE)ret+=2*L.atp;
  if(a==SUL) ret+=2*S.atp;
  if(a==OESTE) ret+=2*O.atp;
  if(a==NORTE){ 
    i=-1;
    j=0;
  }
  if(a==LESTE){
    i=0;
    j=1;
  }
  if(a==SUL){
    i=1;
    j=0;
  }
  if(a==OESTE){
    i=0;
    j=-1;
  } 
  if(Viz(i,j).esp==EU.esp) ret+=40;
  if(Viz(i-1,j).esp==EU.esp) ret--;
  if(Viz(i+i,j).esp==EU.esp) ret--;
  if(Viz(i,j-1).esp==EU.esp) ret--;
  if(Viz(i,j+1).esp==EU.esp) ret--;
  return ret; 
}

/*A funcao atp simplesmente devolve o numero de atps do vizinho da direcao
  dade caso este seja inimigo, MAX_ATP+1 casp contrario. */

static int atp(DIRECAO i){
  if(i==NORTE&&NN.esp!=EU.esp) return viz[1][2].atp;
  if(i==LESTE&&L.esp!=EU.esp) return viz[2][3].atp;
  if(i==SUL&&S.esp!=EU.esp) return viz[3][2].atp;
  if(i==OESTE&&O.esp!=EU.esp) return viz[2][1].atp;
  return MAX_ATP+1;
}

/*A funcao dapub devolve a posicao j do vetor publico da celula na direcao i
  da celula viz[2][2]*/

static int dapub(DIRECAO i, int j){
  if(i==NORTE) return NN.pub[j%4];
  if(i==LESTE) return L.pub[j%4];
  if(i==SUL) return S.pub[j%4];
  if(i==OESTE) return O.pub[j%4];
}


INTENCAO massacre2 (favo ziv[5][5])
{
  carnica.acao = FORTALECE;
  carnica.param=0;
  int i,j,k,min,m;

  if(!iteracoes) carregaprimos();
 
  zeravetor(carnica.pub);
  zeravetor(carnica.futpub);
  for(i=0; i<LADOVIZ; i++){
    for(j=0; j<LADOVIZ; j++) viz[i][j]=ziv[i][j];
  }/* com isso poderei utilizar o vetor global viz ao invs do vetor local ziv */
  if(popespecies[0]){//caso haja celulas vazias, roda a rotina de ocupacao.
    carregaadjO();
    j=maior(adjO);
    if(adjO[j] && EU.atp>1) {
      ocupamax(j);
      return carnica;
    }
  }
  /*Rotina de Ataque*/
  if(EU.atp>2){/*Caso haja ATP para atacar,*/
    min=0,m=NN.atp,k=0;

    /*Achamos o minimo do valor de atp da celula adjacente menos o numero
de celulas aliadas ou vazias adjacentes a ela. Caso haja empate, a ordem de
favorecimento e norte,leste,sul,oeste.*/
    if((NN.esp!=EU.esp)&&(NN.esp)){
      
      i=NN.atp;
     
      if((Viz(-2,0).esp==EU.esp)||!(Viz(-2,0).esp)) i--;
      if((Viz(-1,-1).esp==EU.esp)||!(Viz(-1,-1).esp))i--;
      if((Viz(-1,1).esp==EU.esp)||!(Viz(-1,1).esp)) i--;

      m=i;
      carnica.acao=ATAQUE;
      carnica.dir=NORTE;
      k++;    
    }
    else m=20;
    if((L.esp!=EU.esp)&&(L.esp)){

      i=L.atp;
      if((Viz(0,2).esp==EU.esp)||!(Viz(0,2).esp)) i--;
      if((Viz(1,1).esp==EU.esp)||!(Viz(1,1).esp)) i--;
      if((Viz(-1,1).esp==EU.esp)||!(Viz(-1,1).esp))i--;
     
      if(i<m){
	carnica.dir=LESTE;
	carnica.acao=ATAQUE;
	m=i;
	k++;  
      }  
    }
    if((S.esp!=EU.esp)&&(S.esp)){
   
      i=S.atp;
      if((Viz(2,0).esp==EU.esp)||!(Viz(-2,0).esp)) i--;
      if((Viz(1,1).esp==EU.esp)||!(Viz(-1,-1).esp)) i--;
      if((Viz(1,-1).esp==EU.esp)||!(Viz(-1,1).esp)) i--;
    
      if(i<m){
	m=i;
	carnica.dir=SUL;
	carnica.acao=ATAQUE;
	k++;
      }
    }
    if((O.esp!=EU.esp)&&(O.esp)&&(i<m)){
      
      
      i=O.atp;
      if((Viz(0,-2).esp==EU.esp)||!(Viz(-2,0).esp)) i--;
      if((Viz(-1,-1).esp==EU.esp)||!(Viz(-1,-1).esp)) i--;
      if((Viz(1,-1).esp==EU.esp)||!(Viz(-1,1).esp)) i--;
      if(i<m){      
	m=i;
	carnica.dir=OESTE;
	carnica.acao=ATAQUE;
	k++;
      }
    }

    if(k){/*Se alguma das condicoes acima foi satisfeira*/
      carnica.pub[0]=3;/*O vetor publico e setado em 3, que e o valor para
			 pedir transferencia de ATP*/
      carnica.futpub[0]=3;
      carnica.param=EU.atp-1-gasto[ATAQUE];    
      return carnica;/*E se faz o ataque*/
    }  }
  /*Rotina de Transferencia*/
  if(EU.atp>2){
    
    /*A ideia da rotina de transferencia e a seguinte: Uma celula que decide
atacar, "pede" a transferencia colocando um 3 em seu pub[0], cada celula que 
transferir assumira o pub[0] de seu alvo multiplicado por 2. Desta forma se 
sabera a que distancia esta a batalha. A celula que nao
atacar e nao ocupar, vai entao olhar a sua volta, achando a celula aliada que
tem o menor pub[0] divisivel por 3, isto e, a celula mais perto de uma batalha
que esta pedindo transferencia e transferira para ela.*/

    min =0;
    m=200;
    
    for(i=0;i<4;i++){/*Achando o minimo pub[0]*/
      if((daesp(i)==EU.esp)&&(dapub(i,0)<m)&&(!(dapub(i,0)%3))){
	min=i;
	m=dapub(i,0);
      }
    }
    
    carnica.acao=TRANSF;
    carnica.dir=min;
    carnica.param=EU.atp/2;

    carnica.pub[0]*=2;/*Setando o proprio vetor publico.*/
    
    if(daesp(min)==EU.esp)return carnica;
    
  }

  /*se nenhuma das anteriores, a celula se fortalece*/   

  carnica.acao=FORTALECE;
  
  return carnica;

 
}

/*A funcao varretransO, varre a vizinhanca de 2,2 na direcao x, dando um valor
dependendo do numero de espacos vagos e caminhos para estes espacos.
De autoria de Ubiratan, os detalhes me escapam.*/

int varretransO(int x){
  int i=0;
  transpoe(x);
  if(!TC.esp){
    i+= vago1;
    
    if(!TC2.esp) i+= vago2;
    if(!TCE1.esp){/* lado esquerdo */
      i+= vago2;
      if(!TC1.esp){
	i+= vago3;
	if(!TC2.esp) i+= vago3a;
      }
      if(!TE1.esp){
	i+= vago3;
	if(!TCE2.esp){
	  i+= vago4;
	  if(!TC1.esp) i+= vago4a;
	}
      }
      if(!TE.esp){
	i+= vago3;
	if(!TE2.esp){
	  i+= vago4;
	  if(!TE1.esp) i+= vago4a;
	}
	if(!TBE1.esp){
	  i+= vago4;
	  if(!TE3.esp){
	    i+= vago5;
	    if(!TE2.esp) i+= vago5a;
	  }
	  if(!TB1.esp){
	    i+= vago5;
	    if(!TBE2.esp){
	      i+= vago6;
	      if(!TE3.esp) i+= vago6a;
	    }
	  }
	}
	else if(!TE2.esp && !TE3.esp){
	  i+= vago5;
	  if(!TBE2.esp){
	    i+= vago6;
	    if(!TB1.esp) i+= vago7;
	  }
	}
      }
      else if(!TE1.esp && !TE2.esp){
	i+= vago4;
	if(!TE3.esp){
	  i+= vago5;
	  if(!TBE2.esp) i+= vago6;
	  if(!TBE1.esp){
	    if(!TB1.esp){
	      i+= vago7;
	      if(!TBE2.esp) i+= vago7a;
	    }
	  }
	  else if(!TBE2.esp && !TB1.esp) i+= vago7;
	}
      }
    }
    else if(!TC2.esp && !TC1.esp){/* lado esquerdo cont. */
      i+= vago3;
      if(!TCE2.esp){
	i+= vago4;
	if(!TE1.esp){
	  i+= vago5;
	  if(!TE2.esp){
	    i+= vago6;
	    if(!TE.esp) i+= vago7;
	    if(!TE3.esp){
	      i+= vago7;
	      if(!TBE2.esp) i+= vago8;
	      if(!TBE1.esp){
		i+= vago8;
		if(!TE.esp) i+= vago8a;
		if(!TB1.esp){
		  i+= vago9;
		  if(!TBE2.esp) i+= vago9a;
		  
		}
	      }
	    }
	    else if(!TE.esp && !TBE1.esp){
	      i+= vago8;
	      if(!TB1.esp){
		i+= vago9;
		if(!TBE2.esp) i+= vago10;
	      }      
	    }
	  }
	}
      }
    }
    
    
    if(!TCD1.esp){/* lado direito */
      i+= vago2;
      if(!TC3.esp){
	i+= vago3;
	if(!TC2.esp) i+= vago3a;
      }
      if(!TD1.esp){
	i+= vago3;
	if(!TCD2.esp){
	  i+= vago4;
	  if(!TC3.esp) i+= vago4a;
	}
      }
      if(!TD.esp){
	i+= vago3;
	if(!TD2.esp){
	  i+= vago4;
	  if(!TD1.esp) i+= vago4a;
	}
	if(!TBD1.esp){
	  i+= vago4;
	  if(!TD3.esp){
	    i+= vago5;
	    if(!TD2.esp) i+= vago5a;
	  }
	  if(!TB3.esp){
	    i+= vago5;
	    if(!TBD2.esp){
	      i+= vago6;
	      if(!TD3.esp) i+= vago6a;
	    }
	  }
	}
	else if(!TD2.esp && !TD3.esp){
	  i+= vago5;
	  if(!TBD2.esp){
	    i+= vago6;
	    if(!TB3.esp) i+= vago7;
	  }
	}
      }
      else if(!TD1.esp && !TD2.esp){
	i+= vago4;
	if(!TD3.esp){
	  i+= vago5;
	  if(!TBD2.esp) i+= vago6;
	  if(!TBD1.esp){
	    if(!TB3.esp){
	      i+= vago7;
	      if(!TBD2.esp) i+= vago7a;
	    }
	  }
	  else if(!TBD2.esp && !TB3.esp) i+= vago7;
	}
      }
    }
    else if(!TC2.esp && !TC3.esp){/* lado direito cont. */
      i+= vago3;
      if(!TCD2.esp){
	i+= vago4;
	if(!TD1.esp){
	  i+= vago5;
	  if(!TD2.esp){
	    i+= vago6;
	    if(!TD.esp) i+= vago7;
	    if(!TD3.esp){
	      i+= vago7;
	      if(!TBD2.esp) i+= vago8;
	      if(!TBD1.esp){
		i+= vago8;
		if(!TD.esp) i+= vago8a;
		if(!TB3.esp){
		  i+= vago9;
		  if(!TBD2.esp) i+= vago9a;
		  
		}
	      }
	    }
	    else if(!TD.esp && !TBD1.esp){
	      i+= vago8;
	      if(!TB3.esp){
		i+= vago9;
		if(!TBD2.esp) i+= vago10;
	      }
	      
	    }
	  }
	}
      }
    }
  }
  return i;
}

/*A funcao maior recebe um vetor v de ints e devolve a posicao j que contem o 
maior inteiro do vetor.*/

int maior(int v[4]){
  int i,j;
  j=0;
  for(i=1; i<4; i++){
    if(v[i]>v[j]) j=i;
  }
  return j;
}

/* A funcao menor recebe um vetor v de 4 ints e devolve a posicao j tal que
   v[j] seja a menor do vetor.*/

int menor(int v[4]){
  int i,j;
  j=0;
  for(i=1; i<4; i++){
    if(v[i]&&v[i]<v[j]) j=i;
  }
  return j;
}

/* A funcao zeravetor recebe um vetor v de 4 ints e zera todas suas posicoes*/

void zeravetor(int v[4]){
  int i;
  for(i=1; i<4; i++) v[i]=0;
}

/*A funcao ocupamax recebe uma direcao x e seta a INTENCAO a ocupar nesta
  direcao.*/

void ocupamax(int x){
  carnica.acao= OCUP;
  carnica.dir= x;
  carnica.param= EU.atp-1;
  carnica.pub[0]=1;
  carnica.pub[1]=primo[0];
}

int esp(int x){
  favo a;
  if(x==NORTE)a=C;
  else if(x==LESTE) a=D;
  else if(x==SUL) a=B;
  else if(x==OESTE) a=E;
	  
  if(!a.esp) return NADA;
  else if(a.esp==EU.esp) return MESMA;
  else return OUTRA;
}


int potencia(int valor, int fator){
  int i, d;
  for(i=0; i<PRIMO; i++){
    if(primo[i]!=fator){
      d=valor%primo[i];
      valor=d;
    }
  }
    d=0;
    while(valor!=1){
      i=valor/fator;
      valor=i;
      d++;
    }
    return d;
}

void multprimo(favo a, int t, int d){
  int i;
  for(i=0; i<a.atp; i++) t*=primo[d];
}

int multprimo2(int param, int d){
  int i,t;
  t=1;
  for(i=0; i<param; i++) t*=primo[d];
  return t;
}

void carregaadjO(){
  int i;
  zeravetor(adjO);
  for(i=0; i<4; i++) adjO[i]= varretransO(i);
}

/* A funcao transpoe "gira" a matriz vizinhanca de forma que a direcao x
esteja apontando para o norte, de forma que a matriz possa ser analisada
sempre olhando para o norte, apesar de estarmos olhando em outras direcoes!*/
void transpoe(int x){
  int i,j;
  if(x==NORTE){
    for(i=0; i<LADOVIZ; i++){
      for(j=0; j<LADOVIZ; j++){
	trans[i][j]= viz[i][j];
      }
    }
  }
  else if(x==LESTE){
    for(i=0; i<LADOVIZ; i++){
      for(j=0; j<LADOVIZ; j++){
	trans[LADOVIZ-1-j][i]= viz[i][j];
      }
    }
  }
  else if(x==SUL){
    for(i=0; i<LADOVIZ; i++){
      for(j=0; j<LADOVIZ; j++){
	trans[LADOVIZ-1-i][LADOVIZ-1-j]= viz[i][j];
      }
    }
  }
  else if(x==OESTE){
    for(i=0; i<LADOVIZ; i++){
      for(j=0; j<LADOVIZ; j++){
	trans[j][LADOVIZ-1-i]= viz[i][j];
      }
    }
  }
}

/*A funcao carregaprimos carrefa um vetor com os N primeiros numeros primos,
  para utilizacao no vetor publico*/

void carregaprimos(){
  int primo[N];
  int a,i,k;
  primo[0]=2;
  k=1;
  for(a=3; ;a+=2){
    for(i=0; i<k; i++){
      if(!(a%primo[i])) break;
    }
    if(i==k){
      primo[k]=a;
      k++;
    }
    if(k>N-1) break;
  }
}
