#include "funcs.h"
#include "desenho.h"
#include "motor.h"
#include "especies.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>


void ZeraColmeia (favo[N][N]);

void sorteia (favo[N][N]);

void contaesp (favo[N][N]);

void mostraopilegais();


int contaopilegais[NUM_ESP+1]={0,}; /*Conta operaes ilegais de cada especie*/

int popespecies[NUM_ESP+1]={0,}; /*Conta a populacao de cada especie (posicao 0 do vetor eh o numero de favos vazios)*/

int iteracoes; /*Conta o nmero de iteraes*/

int main ()
{
  int i, j, flag=0;
  static favo Colmeia[N][N];
  iniciagraf(); 
  ZeraColmeia (Colmeia);
  RegistraEspecies();
  sorteia (Colmeia);
  contaesp(Colmeia);
  desenha (Colmeia);
  /*  PlotaTabCor();*/

  for(iteracoes=0; iteracoes <= DURACAO; iteracoes++)
    {
      Itera(Colmeia);
      contaesp(Colmeia);
      desenha(Colmeia);
      desenhaplacar(DURACAO - iteracoes); 
/*       if (iteracoes%1==0) PlotaPizza(); */
      for (j=0; j<NUM_ESP+1; j++)
	if (popespecies[j] == N*N)
	  flag=1;
      if (flag) break;
    }

  printf("\n\nPopulao final\n");
  for (i=1; i<NUM_ESP+1; i++)
    printf("%12.12s\t", especies[i].nome);
  printf("\n");
  for (i=1; i<NUM_ESP+1; i++)
    printf("%12d\t", popespecies[i]);
  printf("\n");
  for (i=1; i<NUM_ESP+1; i++)
    printf("%12d\t", contaopilegais[i]);
  printf("\n");
  getchar ();
  fechagraf();
  return 0;
}

void ZeraColmeia (favo M[N][N]){
  int i, j, k;
  for (i=0; i<N; i++){
    for (j=0; j<N; j++){
      M[i][j].esp = 0;
      M[i][j].atp = 0;
      for (k=0; k<4; k++)
	M[i][j].pub[k] = 0;
    }
  }
}

void sorteia (favo M[N][N])
{
  int i, j, x, y;
  srand(time(NULL));
  for (i=1; i<=NUM_ESP; i++){
    for (j=0; j<N*N/(NUM_ESP*10);){
      x = rand ()%N;
      y = rand ()%N;
      if (M[x][y].esp == 0){
	M[x][y].esp = i;
	M[x][y].atp = 1;
	j++;
      }
    }
  }
}

void contaesp (favo M[N][N])
{
  int i, j;
  for (i=0; i<NUM_ESP+1; i++)
    popespecies[i] = 0;
  for (i=0; i<N; i++)
    for (j=0; j<N; j++)
	 popespecies[M[i][j].esp]++;
}

/*Somente para debugao - chamar a cada iterao na principal*/
void mostraopilegais()
{
  int i;
  static int antopilegais[NUM_ESP+1]={0,};
  for (i=1; i<NUM_ESP+1; i++) 
    printf("%d\t", contaopilegais[i] - antopilegais[i]);
  printf("\n");
  for (i=1; i<NUM_ESP+1; i++)
    antopilegais[i] = contaopilegais[i];
}
