/*

Especie criada por:

Yul Otani
Alexandre Lin

*/



/*----------------------------------------------------------------------------------------------------*/
/*----------------------------------espcie-goban-----------------------------------------------------*/
/*-----------------------------------------------------------15-dez-2004-(QUA)------------------------*/
/*----------------------------------------------------------------------------------------------------*/


/*---------------------------------------------------espcie yul-------------------------------------*/
#include <stdlib.h>
#include "funcs.h"
#include "motor.h"

#define NOME ln(x^n)=n*ln|x| o.O

/*---------------------------------------------------var.globais--------------------------------------*/
extern   int gasto[5];
extern   int popespecies[NUM_ESP+1];
extern   int iteracoes;
INTENCAO kekka;
favo     viz[5][5];

/*---------------------------------------------------funes------------------------------------------*/
INTENCAO    goban      (favo[5][5]);
static void inicializa (void);
static void senban     (void); /*turno 0        */
static void fuseki     (void); /*comeco         */
static void chuuban    (void); /*meio           */
static void genin      (void); /*mov. vertical  */
static void iryounin   (void); /*mov. horizontal*/
static void check      (void); /*checa intencao */
static int  check_1    (void);
static int  check_2    (void);

/*---------------------------------------------------parmetros---------------------------------------*/
#define change 10       /*change inning*/
#define fatoc (50/100.) /*fator de ocupacao*/
#define fataq (70/100.) /*fator de ataque*/
#define fatra (60/100.) /*fator de transf.*/
#define matsu (2+1)     /*min para transf.*/
#define delta 40        /*param. qualquer.*/
#define larg  10        /*param. qualquer.*/

/*---------------------------------------------------sintaxe...---------------------------------------*/
#define jibun viz[2][2]
#define NN    viz[1][2]
#define EE    viz[2][3]
#define SS    viz[3][2]
#define WW    viz[2][1]

/*---------------------------------------------------principal----------------------------------------*/
INTENCAO goban (favo ziv[5][5])
{
  int i,j;
  for(i=0;i<5;i++){
  for(j=0;j<5;j++){
    viz[i][j]=ziv[i][j];
  }} inicializa();

  if      (iteracoes ==      0) senban ();
  else if (iteracoes <= change) fuseki ();
  else                          chuuban();
  check();

  return kekka;
} 

/*---------------------------------------------------CHUUBAN------------------------------------------*/
static void chuuban (void)
{
 int pos,k;
 for(k=0;k<5;k++) if(viz[k][3].esp==jibun.esp && jibun.pub[0] <= viz[k][3].pub[0]   ) {  kekka.pub[0]=viz[k][3].pub[0]+1;  jibun.pub[0]=viz[k][3].pub[0]+1;  }
 for(k=0;k<5;k++) if(viz[k][4].esp==jibun.esp && jibun.pub[0] <= viz[k][4].pub[0]+1 ) {  kekka.pub[0]=viz[k][4].pub[0]+2;  jibun.pub[0]=viz[k][4].pub[0]+2;  }

 pos=(jibun.pub[0])%delta;
 if( pos <= larg ) { genin   (); return; }
 else              { iryounin(); return; }
}

/*---------------------------------------------------genin--------------------------------------------*/
static void genin (void)
{
  if      (NN.esp==0) { kekka.acao  = OCUP; kekka.dir   = NORTE; kekka.param = (int)(jibun.atp*fatoc); }
  else if (SS.esp==0) { kekka.acao  = OCUP; kekka.dir   = SUL  ; kekka.param = (int)(jibun.atp*fatoc); }
  if( kekka.acao == OCUP ) return;
  
  if( jibun.atp > 2)
    {
      if     ( NN.esp != jibun.esp && NN.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
      else if( SS.esp != jibun.esp && SS.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
      else if( EE.esp != jibun.esp && EE.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]+1; }
      else if( WW.esp != jibun.esp && WW.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]-1; }
    } if( kekka.acao==ATAQUE ) return;

  if( jibun.atp > 1)
    {
      if     ( NN.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; } 
      else if( SS.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
      else if( EE.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
      else if( WW.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
    }
  if( kekka.acao==TRANSF ) return;
  return;
}

/*---------------------------------------------------iryounin-----------------------------------------*/
static void iryounin (void)
{
  int pos;
  pos=(jibun.pub[0]%delta)-larg;
  if( pos < (delta-larg)/2 ) /* vai pra esq */
    {
      if      (WW.esp==0) { kekka.acao  = OCUP; kekka.dir   = OESTE; kekka.param = (int)(jibun.atp*fatoc); }
      else if (EE.esp==0) { kekka.acao  = OCUP; kekka.dir   = LESTE; kekka.param = (int)(jibun.atp*fatoc); }
      if( kekka.acao == OCUP ) return;
      
      if( jibun.atp > 2)
	{
	  if      (EE.esp != jibun.esp && EE.esp != 0) { kekka.acao=ATAQUE; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]+1; }
	  else if (WW.esp != jibun.esp && WW.esp != 0) { kekka.acao=ATAQUE; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]-1; }
	  else if (NN.esp != jibun.esp && NN.esp != 0) { kekka.acao=ATAQUE; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
	  else if (SS.esp != jibun.esp && SS.esp != 0) { kekka.acao=ATAQUE; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
	}
      if( kekka.acao==ATAQUE ) return;

      if( jibun.atp > matsu)
	{
	  if     ( EE.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	  else if( WW.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	  else if( NN.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; } 
	  else if( SS.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	}
      if( kekka.acao==TRANSF ) return;
    }
  else   /*--------------vai pra dir?? */
    {
      if      (EE.esp==0) { kekka.acao  = OCUP; kekka.dir   = LESTE; kekka.param = (int)(jibun.atp*fatoc); }
      else if (WW.esp==0) { kekka.acao  = OCUP; kekka.dir   = OESTE; kekka.param = (int)(jibun.atp*fatoc); }
      if( kekka.acao == OCUP ) return;
      
      if( jibun.atp > 2)
	{
	  if     (WW.esp != jibun.esp && WW.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]-1; }
	  else if(EE.esp != jibun.esp && EE.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]+1; }
	  else if(NN.esp != jibun.esp && NN.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
	  else if(SS.esp != jibun.esp && SS.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
	}
      if( kekka.acao==ATAQUE ) return;

      if( jibun.atp > matsu)
	{
	  if     ( WW.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	  else if( EE.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	  else if( NN.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; } 
	  else if( SS.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]; }
	}
      if( kekka.acao==TRANSF ) return;
    }
 return;
}


/*---------------------------------------------------FUSEKI-------------------------------------------*/
static void fuseki (void)
{
 int k;
 for(k=0;k<5;k++) if(viz[k][3].esp==jibun.esp) if( jibun.pub[0] <= viz[k][3].pub[0]   ) { kekka.pub[0]=viz[k][3].pub[0]+1; jibun.pub[0]=viz[k][3].pub[0]+1; }
 for(k=0;k<5;k++) if(viz[k][4].esp==jibun.esp) if( jibun.pub[0] <= viz[k][4].pub[0]+1 ) { kekka.pub[0]=viz[k][4].pub[0]+2; jibun.pub[0]=viz[k][4].pub[0]+2; }

 if      (EE.esp==0) { kekka.acao=OCUP; kekka.dir=LESTE; kekka.param=1; }
 else if (WW.esp==0) { kekka.acao=OCUP; kekka.dir=OESTE; kekka.param=1; }
 else if (NN.esp==0) { kekka.acao=OCUP; kekka.dir=NORTE; kekka.param=1; }
 else if (SS.esp==0) { kekka.acao=OCUP; kekka.dir=SUL;   kekka.param=1; }
 if ( kekka.acao == OCUP ) return;

 if( jibun.atp > 2)
 {
   if     ( EE.esp != jibun.esp && EE.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]+1; }
   else if( WW.esp != jibun.esp && WW.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0]-1; }
   else if( NN.esp != jibun.esp && NN.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
   else if( SS.esp != jibun.esp && SS.esp != 0 ) { kekka.acao=ATAQUE; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fataq); kekka.futpub[0]=jibun.pub[0];   }
 }
 if( kekka.acao==ATAQUE ) return;

 if( jibun.atp > 1)
 {
   if     ( EE.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=LESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]+1; }
   else if( WW.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=OESTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0]-1; }
   else if( NN.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=NORTE ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0];   }
   else if( SS.esp == jibun.esp ) { kekka.acao=TRANSF; kekka.dir=SUL   ; kekka.param=(int)(jibun.atp*fatra); kekka.futpub[0]=jibun.pub[0];   }
 }
 if( kekka.acao==TRANSF ) return;
 
 return;
}

/*---------------------------------------------------SENBAN-------------------------------------------*/
static void senban (void)
{
 int i,k;
 for(i=0;i<TAM_PUB;i++) { jibun.pub[i]=0; kekka.pub[i]=0; kekka.futpub[i]=0; }
 for(k=0;k<5;k++) if(viz[k][3].esp==jibun.esp) { kekka.pub[0]=1; jibun.pub[0]=1; }
 for(k=0;k<5;k++) if(viz[k][4].esp==jibun.esp) { kekka.pub[0]=2; jibun.pub[0]=2; }

 if      (EE.esp==0) { kekka.acao=OCUP; kekka.dir=LESTE; kekka.param=(int)(jibun.atp*fatoc); }
 else if (WW.esp==0) { kekka.acao=OCUP; kekka.dir=OESTE; kekka.param=(int)(jibun.atp*fatoc); }
 else if (NN.esp==0) { kekka.acao=OCUP; kekka.dir=NORTE; kekka.param=(int)(jibun.atp*fatoc); }
 else if (SS.esp==0) { kekka.acao=OCUP; kekka.dir=SUL  ; kekka.param=(int)(jibun.atp*fatoc); }
 return;
}

/*---------------------------------------------------INICIALIZA---------------------------------------*/
static void inicializa (void)
{
 int i;
 kekka.acao  = FORTALECE;
 kekka.dir   = NORTE;
 kekka.param = 0;
 for(i=0;i<TAM_PUB;i++)
    {
     kekka.pub[i]   =jibun.pub[i];
     kekka.futpub[i]=jibun.pub[i];
    } 
 return;
}

/*---------------------------------------------------CHECK--------------------------------------------*/
static void check (void)
{
  if(!check_1()) inicializa();
  if(!check_2()) inicializa(); 
  return;
}

static int check_1 (void)
{
  if( kekka.acao == OCUP )
     {
        switch(kekka.dir)   {
        case NORTE: if(NN.esp==0) return 1;
        case LESTE: if(EE.esp==0) return 1;
        case SUL  : if(SS.esp==0) return 1;
        case OESTE: if(WW.esp==0) return 1;
        default : return 0; }
     }
  if( kekka.acao == ATAQUE )
     {
        switch(kekka.dir)   {
        case NORTE: if(NN.esp !=0 && NN.esp !=jibun.esp) return 1;
        case LESTE: if(EE.esp !=0 && EE.esp !=jibun.esp) return 1;
        case SUL  : if(SS.esp !=0 && SS.esp !=jibun.esp) return 1;
        case OESTE: if(WW.esp !=0 && WW.esp !=jibun.esp) return 1;
        default : return 0; }
     }
  if( kekka.acao == TRANSF )
     {
        switch(kekka.dir)   {
        case NORTE: if(NN.esp ==jibun.esp) return 1;
        case LESTE: if(EE.esp ==jibun.esp) return 1;
        case SUL  : if(SS.esp ==jibun.esp) return 1;
        case OESTE: if(WW.esp ==jibun.esp) return 1;
        default : return 0; }
     }
  if( kekka.acao == FORTALECE ) return 1;
}

static int check_2 (void)
{
  if( kekka.param < 0 ) return 0;
  if( kekka.acao!= FORTALECE)
     {
     if(kekka.param==0)                  return 0;
     if(jibun.atp < 2+gasto[kekka.acao]) return 0;
     }
  if( kekka.param >= jibun.atp - gasto[kekka.acao] )  return 0;
  return 1;
}

/*---------------------------------------------------------------------------------------fin----------*/
